//ccchart plugin http://ngw.jp/~tato/wp/

   window.ccchart.m.dropDraw = {
      //説明
      aboutThis_module: {
        name: 'dropDraw',
        varsion: '0.01',
        create: 20140317,
        dependent: 'ccchart-v1.08.2',
        howtouse: 'http://ngw.jp/~tato/wp/?p=',
        demo: 'http://ngw.jp/~tato/wp/?p=',
        license: 'MIT',
        Author: 'Toshiro Takahashi @toshirot'
      },
      //JSON file ドロップでチャート表示
      dropDraw: function (op, callback){

        //引数 op
        //op.id ドロップ先の要素名 (default document.body)
        //op.bgEnter ドロップ先に入った時の背景色(default 'rgba(180, 180, 180, 0.8)')
        //callback 描画後に実行する(default function(){})

        var that = this; //カレントccchartオブジェクトを変数thatへ渡す
        var toDropElem;  //ドロップされる要素
        var bgEnter;     //ドラッグがドロップ先に入った時の背景色
        var bgLeave;     //ドラッグがドロップ先を出た時の背景色
        var callback = callback?callback:function(){};//コールバック
        var canvas, ctx;

        window.addEventListener("DOMContentLoaded", function(){

          canvas = that.ops[that.id].canvas;
          ctx = canvas.getContext('2d');
          if(!op)op={};

          //ドロップ先の要素名
          var id = op.id;
          toDropElem = document.getElementById(id)|| document.body;
          //ドロップ先に入った時の背景色
          bgEnter = op.bgEnter || 'rgba(180, 180, 180, 0.8)';
          //ドロップ先から出た時の背景色（元の色）
          bgLeave = toDropElem.style.background;

          //各イベント発生時の処理
          toDropElem.addEventListener("dragenter", dragenter);
          toDropElem.addEventListener("dragover", dragenter);
          toDropElem.addEventListener("dragleave", dragleave);
          toDropElem.addEventListener("drop", socketSend);
        });
        function socketSend(evt) {
            //ドロップされたらchartを描画する
            evt.preventDefault();
            var dt = evt.dataTransfer;
            var file = dt.files[0];
            var fr = new FileReader();
            fr.onload = function(event){
                toDropElem.style.background=bgLeave;
                that.init(
                  canvas,
                  JSON.parse(event.target.result),
                  callback
                )
            }
            fr.readAsText(file, 'utf-8');
        }
        function dragenter(e){
            //ドラッグがドロップ先に入った時のデフォルト動作
            e.preventDefault();
            toDropElem.style.background=bgEnter;
        }
        function dragleave(e){
            //ドラッグがドロップ先から出た時のデフォルト動作
            e.preventDefault();
            toDropElem.style.background=bgLeave;
        }
        function preventDefault(e){
           e.preventDefault();

        }

        //メソッドチェーンををつなぐためにthis（ccchart）を返しておきます
        return this;
      }
   };